<?php
/**
 * Templates Name: Elementor
 * Widget: Products Category
 */
$rows = 1;
$display_count = $shop_now = $shop_now_text = '';
$count_item = 'no';
extract($settings);

if (!empty($_css_classes)) {
    $this->add_render_attribute('wrapper', 'class', $_css_classes);
}

$attribute = '';
$this->settings_layout();

$this->add_render_attribute('wrapper', 'class', ['tbay-addon-categories', 'categories', 'tbay-addon-'.$layout_type]);

$this->add_render_attribute('row', 'class', ['categories', 'rows-'.$rows ]);

$attr_row = $this->get_render_attribute_string('row');

// Create a unique transient name based on widget ID and settings
$transient_name = 'urna_product_categories_custom_' . $this->get_id() . '_' . md5(serialize($settings) . $rows);
$cached_output = get_transient($transient_name);

Elementor\Icons_Manager::enqueue_shim();
?> 

<div <?php echo $this->get_render_attribute_string('wrapper'); ?>>
    <?php $this->render_element_heading(); ?>
 
    <div class="tbay-addon-content woocommerce">
        <div class="<?php echo esc_attr($layout_type); ?>-wrapper">
            <?php if ($layout_type === 'grid') : ?>
                <div <?php echo $this->get_render_attribute_string('row'); ?> > 
            <?php endif;  ?> 
    
            <?php
            // If transient does not exist, generate new content and store it
            if (false === $cached_output) {
                ob_start();
                wc_get_template(
                    'layout-categories/' . $layout_type . '-custom.php',
                    array(
                        'categoriestabs' => $categoriestabs,
                        'attr_row' => $attr_row,
                        'rows' => $rows,
                        'count_item' => $count_item,
                        'shop_now' => $shop_now,
                        'shop_now_text' => $shop_now_text
                    )
                );
                $cached_output = ob_get_clean();
                // Store in transient, expires after 1 hour
                set_transient($transient_name, $cached_output, DAY_IN_SECONDS);
            }
            // Display the content (from transient or newly generated)
            echo $cached_output; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
            ?>
        
            <?php if ($layout_type === 'grid') : ?>
                </div> 
            <?php endif;  ?>
        </div>

    </div>

    <?php $this->render_item_button(); ?>

</div>