<?php
/**
 * Templates Name: Elementor
 * Widget: Products Category
 */
$rows = 1;
$category =  $cat_operator = $product_type = $limit = $orderby = $order = '';
extract($settings);

if (!empty($_css_classes)) {
    $this->add_render_attribute('wrapper', 'class', $_css_classes);
}

if (empty($settings['category'])) {
    return;
}
$this->add_render_attribute('wrapper', 'class', ['tbay-addon-'. $layout_type]);

$layout_type = $settings['layout_type'];
$this->settings_layout();
 
/** Get Query Products */
$loop = urna_get_query_products($category, $cat_operator, $product_type, $limit, $orderby, $order);

$this->add_render_attribute('row', 'class', ['rows-'.$rows ]);
$attr_row = $this->get_render_attribute_string('row');

// Create a unique transient name based on widget ID and settings
$transient_name = 'urna_product_category_' . $this->get_id() . '_' . md5(serialize($settings) . $rows);
$cached_output = get_transient($transient_name);

?>

<div <?php echo $this->get_render_attribute_string('wrapper'); ?>>
    <?php $this->render_element_heading(); ?>

    <div class="tbay-addon-content">
        <?php if (!empty($feature_image['id'])) : ?>
            <div class="product-category-content row">
                <div class="col-md-3 d-md-block d-sm-none d-xs-none">
                    <?php $this->render_item_image($settings) ?>
                </div>            
                <div class="col-md-9 products grid-wrapper woocommerce">
                    <?php
                    // If transient does not exist, generate new content and store it
                    if (false === $cached_output) {
                        ob_start();
                        wc_get_template(
                            'layout-products/' . $layout_type . '.php',
                            array(
                                'loop' => $loop,
                                'attr_row' => $attr_row,
                                'layout_type' => $layout_type,
                                'rows' => $rows
                            )
                        );
                        $cached_output = ob_get_clean();
                        // Store in transient, expires after 1 hour
                        set_transient($transient_name, $cached_output, HOUR_IN_SECONDS);
                    }
                    // Display the content (from transient or newly generated)
                    echo $cached_output; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
                    ?>
                </div>
            </div>
        <?php else : ?>
            <div class="products grid-wrapper woocommerce">
                <?php
                // If transient does not exist, generate new content and store it
                if (false === $cached_output) {
                    ob_start();
                    wc_get_template(
                        'layout-products/' . $layout_type . '.php',
                        array(
                            'loop' => $loop,
                            'attr_row' => $attr_row,
                            'layout_type' => $layout_type,
                            'rows' => $rows
                        )
                    );
                    $cached_output = ob_get_clean();
                    // Store in transient, expires after 1 hour
                    set_transient($transient_name, $cached_output, HOUR_IN_SECONDS);
                }
                // Display the content (from transient or newly generated)
                echo $cached_output; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
                ?>
            </div>
        <?php endif; ?>
    </div>
</div>