<?php
/**
 * Templates Name: Elementor
 * Widget: Products
 */
$rows = 1;
extract($settings);
$this->settings_layout();

if (!empty($_css_classes)) {
    $this->add_render_attribute('wrapper', 'class', $_css_classes);
}

if (isset($limit) && !((bool) $limit)) {
    return;
}

$show_des = (isset($show_des) && $show_des === 'yes') ? true : false;

$this->add_render_attribute('wrapper', 'class', ['products', 'tbay-addon-'. $layout_type]);

/** Get Query Products */
$loop = urna_get_query_products($categories, $cat_operator, $product_type, $limit, $orderby, $order);

$category = '';
if (is_array($categories) && count($categories) === 1) {
    $category = $categories[0];
} elseif (!empty($categories)) {
    $category = $categories;
}

$this->add_render_attribute('row', 'class', ['rows-'.$rows ]);
$attr_row = $this->get_render_attribute_string('row');

// Create a unique transient name based on widget ID and settings
$transient_name = 'urna_products_' . $this->get_id() . '_' . md5(serialize($settings) . $rows);
$cached_output = get_transient($transient_name);

?>

<div <?php echo $this->get_render_attribute_string('wrapper'); ?>>
    <?php $this->render_element_heading(); ?>

    <div class="tbay-addon-content woocommerce">
        <div class="<?php echo esc_attr($layout_type); ?>-wrapper">
            <?php
            // If transient does not exist, generate new content and store it
            if (false === $cached_output) {
                ob_start();
                wc_get_template(
                    'layout-products/' . $layout_type . '.php',
                    array(
                        'loop' => $loop,
                        'attr_row' => $attr_row,
                        'layout_type' => $layout_type,
                        'rows' => $rows,
                        'show_des' => $show_des
                    )
                );
                $cached_output = ob_get_clean();
                // Store in transient, expires after 8 hour
                set_transient($transient_name, $cached_output, 8*DAY_IN_SECONDS);
            }
            // Display the content (from transient or newly generated)
            echo $cached_output; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
            ?>
        </div>
    </div>
    <?php $this->render_item_button($category); ?>
</div>